
{*-------------------------------------------------------------------------------*}
{* VerSionPro for PengWin -- a version info manager for the mere mortals         *}
{*	(penguins included)                                                          *}
{* 	Copyright (c) Dinh DOAN VAN BIEN																						 *}
{* 	May be used by everybody for any purpose, provided that:                     *}
{*		- My copyright stuff is not removed                                        *}
{*    - Distribution of this package or of packages derived from it includes     *}
{*		  source code as well as the executables                                   *}
{*    - You send me your additions (no binaries, source code only)               *}
{*    - This package is not selled to make undue profit on my hard pengwin work  *}
{*    - etc.                                                                     *}
{*  In fact I'd like to distribute this package under the GNU License but I      *}
{*  don't know how to do that, so if someone can give me a clue, drop me a mail  *}
{*  I can be reached at "dihn@msn.com".                                          *}
{*-------------------------------------------------------------------------------*}
{* 	Acknowledgements:                                                            *}
{* 		TMRUFileList is Copyright (c) Brad Stowers (bstower@pobox.com              *}
{*-------------------------------------------------------------------------------*}
{*  Compilation notes:                                                           *}
{*   	You will need Brad Stowers'TMRUFileList component to compile this          *}
{*    If you change the Version.RC file you must recompile it using DRCC32       *}
{*-------------------------------------------------------------------------------*}
{*	History:                                                                     *}
{*	Version 1.0 - March 1997																										 *}
{*		It works but it's not thoroughly tested.																	 *}
{*		TODO: use XXXUpdateResource API calls to update directly                   *}
{*				  the version information in the exe's.                                *}
{*	  TODO: make a cleverer parser to avoid all the ugly tag info                *}
{*		TODO: save some current values to the registry (i LOVE the registry)       *}
{*-------------------------------------------------------------------------------*}

unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, MRUList;

const
	IDI_MAINICON = 'MAINICON';
	MSG_COPYRIGHT = '%s - The UltiMaTe FREEWARE VerSiOn Manager ;-)' + #13 + #10 +
  	#13 + #10 +	'Copyright  1997 Dinh DOAN VAN BIEN';

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    SpeedPanel: TPanel;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    PasteBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    StatusBar: TStatusBar;
    NewBtn: TSpeedButton;
    PasteItemAsFile: TMenuItem;
    MRU: TMRUFileList;
    procedure FormCreate(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure FileOpenItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PasteItemAsFileClick(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure MRUMRUItemClick(Sender: TObject; AFilename: string);
  private
    { Private declarations }
    procedure CreateMDIChild(const Name: string);
    procedure ShowHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin;

procedure TMainForm.FormCreate(Sender: TObject);
begin
	Caption := Application.Title;
  Application.OnHint := ShowHint;
  Screen.OnActiveFormChange := UpdateMenuItems;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusBar.SimpleText := Application.Hint;
end;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.LoadFromFile(Name);
  if FileExists(Name) then
  	MRU.AddItem(Name);
end;

procedure TMainForm.FileNewItemClick(Sender: TObject);
begin
  CreateMDIChild(Format(FTM_UNTITLED, [MDIChildCount + 1]));
end;

procedure TMainForm.FileOpenItemClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateMDIChild(OpenDialog.FileName);
end;

procedure TMainForm.FileCloseItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    ActiveMDIChild.Close
  else
  	MessageBeep(MB_ICONWARNING);
end;

procedure TMainForm.FileSaveItemClick(Sender: TObject);
begin
  { save current file (ActiveMDIChild points to the window) }
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).SaveToFile
  else
  	MessageBeep(MB_ICONWARNING);
end;

procedure TMainForm.FileSaveAsItemClick(Sender: TObject);
begin
  { save current file under new name }
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).SaveAsFile
  else
  	MessageBeep(MB_ICONWARNING);
end;

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.CopyItemClick(Sender: TObject);
begin
  {copy selection to clipboard}
  if ActiveMDIChild <> nil then
  	TMDIChild(ActiveMDIChild).CopyToClipboard
  else
  	MessageBeep(MB_ICONWARNING);
end;

procedure TMainForm.PasteItemClick(Sender: TObject);
begin
  {paste from the clipboard}
  if ActiveMDIChild <> nil then
  	TMDIChild(ActiveMDIChild).PasteFromClipboard
  else
  	PasteItemAsFile.Click;
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure TMainForm.UpdateMenuItems(Sender: TObject);
begin
  FileCloseItem.Enabled := MDIChildCount > 0;
  FileSaveItem.Enabled := MDIChildCount > 0;
  FileSaveAsItem.Enabled := MDIChildCount > 0;
  CopyItem.Enabled := MDIChildCount > 0;
  PasteItem.Enabled := MDIChildCount > 0;
  SaveBtn.Enabled := MDIChildCount > 0;
  CopyBtn.Enabled := MDIChildCount > 0;
  // It's a "polymorphic" button
  //PasteBtn.Enabled := MDIChildCount > 0;
  WindowCascadeItem.Enabled := MDIChildCount > 0;
  WindowTileItem.Enabled := MDIChildCount > 0;
  WindowArrangeItem.Enabled := MDIChildCount > 0;
  WindowMinimizeItem.Enabled := MDIChildCount > 0;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange := nil;
end;

procedure TMainForm.PasteItemAsFileClick(Sender: TObject);
begin
	FileNewItem.Click;
  PasteItem.Click;
end;

procedure TMainForm.HelpAboutItemClick(Sender: TObject);
var
  aboutMsg: String;
  mbox: TMsgBoxParams;
begin
	aboutMsg := Format(MSG_COPYRIGHT, [Application.Title]);

  FillChar(mbox, sizeof(TMsgBoxParams), 0);
  with mbox do
  begin
  	cbSize := sizeof(TMsgBoxParams);
  	hwndOwner := Handle;
  	hInstance := System.HInstance;
  	lpszText := PChar(aboutMsg);
  	lpszCaption := PChar('About ' + Application.Title);
  	dwStyle := MB_TOPMOST or MB_USERICON;
  	lpszIcon := IDI_MAINICON;
  	dwContextHelpId := 0;
  	lpfnMsgBoxCallback := nil;
  	dwLanguageId := (LANG_NEUTRAL shl 10) or SUBLANG_DEFAULT;
  end;

// I think that this interferes with TApplication
// But it does such a nice message box...

  MessageBoxIndirect(mbox);
  MessageBeep(MB_OK);
end;

procedure TMainForm.MRUMRUItemClick(Sender: TObject; AFilename: string);
begin
	CreateMDIChild(AFileName);	// Thanks Brad!
end;

end.
